#include <windows.h>
#include <commctrl.h>
#include <tchar.h>

#pragma comment(lib,"comctl32.lib")

#define ID_LISTVIEW 100


#define IMAGE_WIDTH 96	//	1̉摜̉
#define IMAGE_HIGHT 16	//	1̉摜̍

WNDPROC default_listview_proc;	//	fBtHgXgr[vV[W[

//  TuNXs߂̃Xgr[EChEvV[W[
LRESULT CALLBACK    ListViewProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);

//	ɐ`悵C[WXgɓo^
//	n-1ȊO̎nŎw肳ꂽC[Wu
void make_line_img(HIMAGELIST hImg,HDC hdc,int s,COLORREF color,int n=-1);
void make_line_img(HBITMAP* ,HIMAGELIST hImg,HDC hdc,int s,COLORREF color,int n=-1);

//	Xgr[ɐACRƕo^
void line_style(HWND hList,int Item,int subitem,int s);

//	Ǘ\

struct LINE_STYLE{
	TCHAR* text;
	int style;
	COLORREF color;
};

//	̐

LINE_STYLE ls[]={
	{	TEXT("1"),PS_SOLID , RGB(0xff,0,0) },
	{	TEXT("2"),PS_DASH  , RGB(0,0xff,0) },
	{	TEXT("3"),PS_DOT   , RGB(0,0,0xff) },
	{ 0,0,0 }};

TCHAR* szClassName=TEXT("Xgr[3");
HINSTANCE hInst;

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst,
	TCHAR* lpszCmdLine, int nCmdShow){
	HWND hWnd;
	MSG lpMsg;
	WNDCLASS myProg;
	hInst=hInstance;

	if (!hPreInst) {
		myProg.style = CS_HREDRAW | CS_VREDRAW;
		myProg.lpfnWndProc = WndProc;
		myProg.cbClsExtra = 0;
		myProg.cbWndExtra = 0;
		myProg.hInstance = hInstance;
		myProg.hIcon = NULL;
		myProg.hCursor = LoadCursor(NULL, IDC_ARROW);
		myProg.hbrBackground = (HBRUSH__ *)GetStockObject(WHITE_BRUSH);
		myProg.lpszMenuName = NULL;
		myProg.lpszClassName = szClassName;
		if (!RegisterClass(&myProg))
			return FALSE;
    }
	hWnd = CreateWindow(szClassName,
		TEXT("Xgr[3"),
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		350,
		150,
		NULL,
		NULL,
		hInstance,
		NULL);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	while (GetMessage(&lpMsg, NULL, 0, 0)){
		TranslateMessage(&lpMsg);
		DispatchMessage(&lpMsg);
	}
	return int(lpMsg.wParam);
}

// EBhEvV[W[

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	static HIMAGELIST hImg;
	static HWND hList;
    LV_COLUMN lvcol;
	LV_ITEM item;

	HDC hdc;
	DWORD ds;
	int n;

	switch(msg){
case WM_CREATE:{
        hList = CreateWindowEx(0,
			WC_LISTVIEW, TEXT(""),
			WS_CHILD | WS_VISIBLE | LVS_REPORT,
			0, 0, 0, 0,
			hWnd,
			(HMENU)ID_LISTVIEW,
			hInst,
			NULL);
//	Xgr[gX^C̐ݒ
		ds=ListView_GetExtendedListViewStyle(hList);
		ds |= LVS_EX_GRIDLINES  | LVS_EX_SUBITEMIMAGES | LVS_EX_FULLROWSELECT;
		ListView_SetExtendedListViewStyle(hList,ds);
//	Xgr[̃TuNX
		default_listview_proc=(WNDPROC)GetWindowLongPtr(hList,GWLP_WNDPROC);
		SetWindowLongPtr(hList,GWLP_WNDPROC,(LONG_PTR)ListViewProc);
//	1ڃwb_[o^@_~[
        lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
        lvcol.fmt = LVCFMT_LEFT;
		lvcol.cx = 0;
        lvcol.pszText = TEXT("");
        lvcol.iSubItem = 0;
        ListView_InsertColumn(hList, 0, &lvcol);
//	2ڃwb_[o^				
		lvcol.cx = 128;
        lvcol.pszText = TEXT("");
        lvcol.iSubItem = 1;
        ListView_InsertColumn(hList, 1, &lvcol);
//	3ڃwb_[o^				
        lvcol.cx = 256;
        lvcol.pszText = TEXT("");
        lvcol.iSubItem = 2;
        ListView_InsertColumn(hList, 2, &lvcol);

//	C[WXg쐬
		hImg = ImageList_Create(IMAGE_WIDTH , IMAGE_HIGHT , ILC_COLOR32, 5 , 0);
//	C[WXg̓o^
		hdc=GetDC(hWnd);

		HBITMAP hbitmap;
		BITMAPINFO bmp;

	//	ɃfoCXƗrbg}bv(DIB)쐬B
		ZeroMemory(&bmp,sizeof(bmp));
		bmp.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
		bmp.bmiHeader.biBitCount=32;
		bmp.bmiHeader.biPlanes=1;
		bmp.bmiHeader.biWidth=IMAGE_WIDTH;
		bmp.bmiHeader.biHeight=-IMAGE_HIGHT;
		hbitmap=CreateDIBSection(NULL,&bmp,DIB_RGB_COLORS,NULL , NULL,0);

		for(n=0 ; ls[n].text ; n++){
			make_line_img( &hbitmap,hImg , hdc , ls[n].style , ls[n].color ,-1);
		}
		DeleteObject(hbitmap);

//  C[WXgXgr[Ɋ֘At
		ListView_SetImageList(hList , hImg , LVSIL_SMALL);

		for(n=0;ls[n].text;n++){
//	1ڃACe̓o^
			item.mask = LVIF_TEXT | LVIF_PARAM | LVIF_IMAGE;
			item.pszText = TEXT("");
			item.iItem = n;
			item.iSubItem = 0;
			item.lParam = n;
			item.iImage=-1;
			ListView_InsertItem(hList, &item);
//	2ڃACe̓o^
			item.mask = LVIF_TEXT;
			item.pszText = ls[n].text;
			item.iSubItem = 1;
			ListView_SetItem(hList, &item);
//	3ڃACe̓o^
			line_style(hList , n , 2 , ls[n].style);
		}
		ReleaseDC(hWnd,hdc);
		break;
			   }
	case WM_SIZE:
		MoveWindow(hList, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
        break;

    case WM_DESTROY:
        PostQuitMessage(0);
        break;

    default:
        return(DefWindowProc(hWnd, msg, wParam, lParam));
    }
    return (0L);
}


//  TuNXs߂̃Xgr[EChEvV[W[

LRESULT CALLBACK ListViewProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam){
	NMHEADER* pnmhdr;
	switch(msg){
	case WM_NOTIFY:
		pnmhdr=(NMHEADER*)lParam;
		switch(pnmhdr->hdr.code){
		case HDN_ENDTRACK:	//	Xgr[wb_[̃fBoC_[̃hbOIƂ
		case HDN_BEGINTRACK:	//	Xgr[wb_[̃fBoC_[̃hbOJnƂ
		case HDN_TRACK:	//	Xgr[wb_[̃fBoC_[̃hbO
		case HDN_DIVIDERDBLCLICKW:	//	Xgr[wb_[̃fBoC_[Ń_uNbNƂ
			if(pnmhdr->iItem==0){
				return TRUE;	//	fBtHg̃vV[W[֏nȂ(񕝕ύXbZ[W𖳎)
			}
		}
	}
    return  CallWindowProc((WNDPROC)default_listview_proc,hWnd,msg,wParam,lParam);
}

//	ɐ`悵C[WXgɓo^
//	n-1ȊO̎nŎw肳ꂽC[Wu

void make_line_img(HBITMAP* hbitmap,HIMAGELIST hImg,HDC hdc,int s,COLORREF color,int n){
	HDC img_hdc;

	//	ʂƌ݊̂foCXReLXg쐬
	img_hdc=CreateCompatibleDC(hdc);
	SelectObject(img_hdc , *hbitmap);

	HPEN hPen,hOldPen;
	hPen=CreatePen(s, 1, color );

	hOldPen=(HPEN__ *)SelectObject(img_hdc, hPen);

	PatBlt(img_hdc , 0 , 0 , IMAGE_WIDTH , IMAGE_HIGHT , WHITENESS);

	SetBkMode(img_hdc,TRANSPARENT);	// ǰԂɐFtȂ
	MoveToEx(img_hdc,0,IMAGE_HIGHT/2,NULL);
	LineTo(img_hdc,IMAGE_WIDTH,IMAGE_HIGHT/2);

	SelectObject(img_hdc, hOldPen);
	DeleteObject(hPen);

// C[WXgɓo^OɃfoCXReLXg폜Ȃ΂ȂȂ
//	폜ȂƐ^ȉ摜\邾łB
	DeleteDC(img_hdc);
	if(n == -1)
		ImageList_AddMasked(hImg ,*hbitmap,RGB(255,255,255));
	else
		ImageList_Replace(hImg ,n,*hbitmap,0);
}


//	Xgr[ɐACRƕo^

void line_style(HWND hList,int Item,int subitem,int s){
	TCHAR* lst[]={	TEXT("PS_SOLID"),
					TEXT("PS_DASH"),
					TEXT("PS_DOT"),
					TEXT("PS_DASHDOT"),
					TEXT("PS_DASHDOTDOT"),0 };
	
	int ls[]={		PS_SOLID,
					PS_DASH,
					PS_DOT,
					PS_DASHDOT,
					PS_DASHDOTDOT,
					0 };
	LV_ITEM item;

	item.mask=LVIF_TEXT | LVIF_IMAGE;
	item.pszText = lst[s];
	item.iItem=Item;
	item.iSubItem = subitem;
	item.iImage=Item;
	ListView_SetItem(hList, &item);
}
